'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _babelTemplate = require('babel-template');

var _babelTemplate2 = _interopRequireDefault(_babelTemplate);

var _util = require('../util');

var _util2 = _interopRequireDefault(_util);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var originalTemplate = (0, _babelTemplate2.default)('\n  NAME.map((PARAMS) => {\n    return ELEMENT;\n  })\n');

var loopSyntax = function loopSyntax(types, nodePath) {
  var index = _util2.default.getAttributeIndex(nodePath, 'data-for');

  if (index === -1) {
    throw new TypeError('Conditional SyntaxError');
  }

  var loopExpression = _util2.default.getAttribute(nodePath, 'data-for');
  if (!loopExpression) {
    throw new SyntaxError('data-for attribute not found!');
  }

  loopExpression = loopExpression.value.value;
  loopExpression = loopExpression.split(/ in /).map(function (variable) {
    return variable.trim();
  });

  if (loopExpression.length !== 2) {
    throw new SyntaxError('data-for unknown syntax: A in B');
  }

  // 무한 루프를 피하기 위해 사용됩니다.
  // to avoid infinite loop.
  _util2.default.removeAttribute(nodePath, index);

  var targetName = types.Identifier(loopExpression[1]);
  var params = types.Identifier(loopExpression[0].replace(/\(|\)/g, ''));

  var syntax = originalTemplate({
    NAME: targetName,
    PARAMS: params,
    ELEMENT: nodePath.node
  });

  return syntax;
};

exports.default = loopSyntax;